/*----- PROTECTED REGION ID(Daresbury.cpp) ENABLED START -----*/
static const char *RcsId = "$Id:  $";
//=============================================================================
//
// file :        Daresbury.cpp
//
// description : C++ source for the Daresbury class and its commands.
//               The class is derived from Device. It represents the
//               CORBA servant object which will be accessed from the
//               network. All commands which can be executed on the
//               Daresbury are implemented in this file.
//
// project :     Daresbury
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
// $Author:  $
//
// $Revision:  $
// $Date:  $
//
// $HeadURL:  $
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#include <Daresbury.h>
#include <DaresburyClass.h>

#include <Serial.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>

#ifndef WIN32
#include <sys/stat.h>
#include <sys/types.h>
#include <sys/time.h>
#endif

// -- Daresbury serial protocol --

#define STR(x)          (char *)(x)
#define	READ_STATE	STR("ST 0\x0d")
#define RESET		STR("RS 0\x0d")
#define PSCOMS		STR("Pscoms\x0d")
#define PROCS		STR("PROCS\x0d")

/*----- PROTECTED REGION END -----*/	//	Daresbury.cpp

/**
 *  Daresbury class description:
 *    Handle PSS crate hardware
 */

//================================================================
//  The following table gives the correspondence
//  between command and method names.
//
//  Command name             |  Method name
//================================================================
//  State                    |  dev_state
//  Status                   |  Inherited (no method)
//  DevRead                  |  dev_read
//  GetAllDescription        |  get_all_description
//  GetHistoryInfo           |  get_history_info
//  GetInterlockDescription  |  get_interlock_description
//  GetInterlockState        |  get_interlock_state
//  ReadInterlockHistory     |  read_interlock_history
//  Reset                    |  reset
//  SetInterlockDescription  |  set_interlock_description
//  EnableSMS                |  enable_sms
//  DisableSMS               |  disable_sms
//  GetSMS                   |  get_sms
//================================================================

//================================================================
//  Attributes managed is:
//================================================================
//  Interlocks  |  Tango::DevShort	Spectrum  ( max = 1024)
//================================================================

namespace Daresbury_ns
{
/*----- PROTECTED REGION ID(Daresbury::namespace_starting) ENABLED START -----*/

//	static initializations

/*----- PROTECTED REGION END -----*/	//	Daresbury::namespace_starting

//--------------------------------------------------------
/**
 *	Method     : Daresbury::Daresbury()
 *	Description: Constructors for a Tango device
 *                implementing the classDaresbury
 */
//--------------------------------------------------------
Daresbury::Daresbury(Tango::DeviceClass *cl, std::string &s)
 : TANGO_BASE_CLASS(cl, s.c_str())
{
	/*----- PROTECTED REGION ID(Daresbury::constructor_1) ENABLED START -----*/
	init_device();
	
	/*----- PROTECTED REGION END -----*/	//	Daresbury::constructor_1
}
//--------------------------------------------------------
Daresbury::Daresbury(Tango::DeviceClass *cl, const char *s)
 : TANGO_BASE_CLASS(cl, s)
{
	/*----- PROTECTED REGION ID(Daresbury::constructor_2) ENABLED START -----*/
	init_device();
	
	/*----- PROTECTED REGION END -----*/	//	Daresbury::constructor_2
}
//--------------------------------------------------------
Daresbury::Daresbury(Tango::DeviceClass *cl, const char *s, const char *d)
 : TANGO_BASE_CLASS(cl, s, d)
{
	/*----- PROTECTED REGION ID(Daresbury::constructor_3) ENABLED START -----*/
	init_device();
	
	/*----- PROTECTED REGION END -----*/	//	Daresbury::constructor_3
}
//--------------------------------------------------------
Daresbury::~Daresbury()
{
	delete_device();
}

//--------------------------------------------------------
/**
 *	Method     : Daresbury::delete_device()
 *	Description: will be called at device destruction or at init command
 */
//--------------------------------------------------------
void Daresbury::delete_device()
{
	DEBUG_STREAM << "Daresbury::delete_device() " << device_name << std::endl;
	/*----- PROTECTED REGION ID(Daresbury::delete_device) ENABLED START -----*/
	
	//	Delete device allocated objects
	nb_log = 0;
	delete logs;
	delete theSerial;
	delete smsDevice;
	delete mailSender;
	
	/*----- PROTECTED REGION END -----*/	//	Daresbury::delete_device
	delete[] attr_Interlocks_read;
}

//--------------------------------------------------------
/**
 *	Method     : Daresbury::init_device()
 *	Description: will be called at device initialization.
 */
//--------------------------------------------------------
void Daresbury::init_device()
{
	DEBUG_STREAM << "Daresbury::init_device() create device " << device_name << std::endl;
	/*----- PROTECTED REGION ID(Daresbury::init_device_before) ENABLED START -----*/
	
	//	Initialization before get_device_property() call
	
	/*----- PROTECTED REGION END -----*/	//	Daresbury::init_device_before


	//	Get the device properties from database
	get_device_property();

	attr_Interlocks_read = new Tango::DevShort[1024];
	/*----- PROTECTED REGION ID(Daresbury::init_device) ENABLED START -----*/
	
	//	Initialize device

	// Create handle to the serial line
  try {

    theSerial = new Tango::DeviceProxy(serial_line);

  } catch (Tango::DevFailed &e) {

    cerr << "ERROR: cannot import " << e.errors[0].desc << endl;
    exit(0);

  }
	
	// Create handle to the SMS (if defined)
	/*
	string smsDeviceName = ((DaresburyClass *)get_device_class())->sMSDevice;
	
	if( smsDeviceName.length()>0 ) {
	
   	  smsNumber = ((DaresburyClass *)get_device_class())->sMSPhoneNumber;
	
	  try {
	
	    smsDevice = new Tango::DeviceProxy(smsDeviceName);
	
	  } catch(Tango::DevFailed &e) {
	
            cerr << "ERROR: cannot import " << e.errors[0].desc << endl;
	    exit(0);
	   
	  }
	
	}
	*/
	
	mailSender = new MailSender("smtp.esrf.fr");
	
	start_time = time(NULL);
	
	// Initialise the serial
  try {
    initialise_pscom();
  } catch (Tango::DevFailed &e) {
    cerr << "WARNING: cannot initialise pscom on " << serial_line << ": ";
    cerr << e.errors[0].desc << endl;
  }
	
	// Create interlock image	
	logs                 = new ItlkLog[MAX_LOG];
	nb_log               = 0;

  // init default
  set_state(Tango::ON);
  set_status("The device is initialising.");
  memset(descriptions, 0, sizeof(char *) * MAX_MODS * 8);
  for (int i = 0; i < MAX_MODS; i++) {
    load_descriptions(i);
    load_alarms(i);
  }
  strcpy(last_response, "");
	
	/*----- PROTECTED REGION END -----*/	//	Daresbury::init_device
}

//--------------------------------------------------------
/**
 *	Method     : Daresbury::get_device_property()
 *	Description: Read database to initialize property data members.
 */
//--------------------------------------------------------
void Daresbury::get_device_property()
{
	/*----- PROTECTED REGION ID(Daresbury::get_device_property_before) ENABLED START -----*/
	
	//	Initialize property data members
	init_pscom=0;
	serial_line="";
	smsNumber = "";
	smsDevice = NULL;
	theSerial = NULL;
	mailSender = NULL;
	
	/*----- PROTECTED REGION END -----*/	//	Daresbury::get_device_property_before


	//	Read device properties from database.
	Tango::DbData	dev_prop;
	dev_prop.push_back(Tango::DbDatum("Serial_line"));
	dev_prop.push_back(Tango::DbDatum("Init_pscom"));

	//	is there at least one property to be read ?
	if (dev_prop.size()>0)
	{
		//	Call database and extract values
		if (Tango::Util::instance()->_UseDb==true)
			get_db_device()->get_property(dev_prop);

		//	get instance on DaresburyClass to get class property
		Tango::DbDatum	def_prop, cl_prop;
		DaresburyClass	*ds_class =
			(static_cast<DaresburyClass *>(get_device_class()));
		int	i = -1;

		//	Try to initialize Serial_line from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  serial_line;
		else {
			//	Try to initialize Serial_line from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  serial_line;
		}
		//	And try to extract Serial_line value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  serial_line;

		//	Try to initialize Init_pscom from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  init_pscom;
		else {
			//	Try to initialize Init_pscom from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  init_pscom;
		}
		//	And try to extract Init_pscom value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  init_pscom;

	}

	/*----- PROTECTED REGION ID(Daresbury::get_device_property_after) ENABLED START -----*/
	
	//	Check device property data members init
	
	/*----- PROTECTED REGION END -----*/	//	Daresbury::get_device_property_after
}

//--------------------------------------------------------
/**
 *	Method     : Daresbury::always_executed_hook()
 *	Description: method always executed before any command is executed
 */
//--------------------------------------------------------
void Daresbury::always_executed_hook()
{
	DEBUG_STREAM << "Daresbury::always_executed_hook()  " << device_name << std::endl;
	/*----- PROTECTED REGION ID(Daresbury::always_executed_hook) ENABLED START -----*/
	
	//	code always executed before all requests
	
	/*----- PROTECTED REGION END -----*/	//	Daresbury::always_executed_hook
}

//--------------------------------------------------------
/**
 *	Method     : Daresbury::read_attr_hardware()
 *	Description: Hardware acquisition for attributes
 */
//--------------------------------------------------------
void Daresbury::read_attr_hardware(TANGO_UNUSED(std::vector<long> &attr_list))
{
	DEBUG_STREAM << "Daresbury::read_attr_hardware(std::vector<long> &attr_list) entering... " << std::endl;
	/*----- PROTECTED REGION ID(Daresbury::read_attr_hardware) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	Daresbury::read_attr_hardware
}

//--------------------------------------------------------
/**
 *	Read attribute Interlocks related method
 *
 *
 *	Data type:	Tango::DevShort
 *	Attr type:	Spectrum max = 1024
 */
//--------------------------------------------------------
void Daresbury::read_Interlocks(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Daresbury::read_Interlocks(Tango::Attribute &attr) entering... " << std::endl;
	/*----- PROTECTED REGION ID(Daresbury::read_Interlocks) ENABLED START -----*/

	if( get_state()==Tango::ON ) {
	  attr.set_value(attr_Interlocks_read , MAX_MODS);
	} else {
          Tango::Except::throw_exception(
      	     (const char *)"Daresbury::error_read",
       	     (const char *)get_status().c_str(),
       	     (const char *)"Daresbury::read_attr(interlocks)");
		
  	}
	
	/*----- PROTECTED REGION END -----*/	//	Daresbury::read_Interlocks
}

//--------------------------------------------------------
/**
 *	Method     : Daresbury::add_dynamic_attributes()
 *	Description: Create the dynamic attributes if any
 *                for specified device.
 */
//--------------------------------------------------------
void Daresbury::add_dynamic_attributes()
{
	/*----- PROTECTED REGION ID(Daresbury::add_dynamic_attributes) ENABLED START -----*/
	
	//	Add your own code to create and add dynamic attributes if any
	
	/*----- PROTECTED REGION END -----*/	//	Daresbury::add_dynamic_attributes
}

//--------------------------------------------------------
/**
 *	Command State related method
 *	Description: This command gets the device state (stored in its device_state data member) and returns it to the caller.
 *
 *	@returns Device state
 */
//--------------------------------------------------------
Tango::DevState Daresbury::dev_state()
{
	DEBUG_STREAM << "Daresbury::State()  - " << device_name << std::endl;
	/*----- PROTECTED REGION ID(Daresbury::dev_state) ENABLED START -----*/
	
	Tango::DevState	argout = Tango::UNKNOWN;

	char *read_argout = last_response;
	char  status[4096];
	int   module,k,rs;
	unsigned short relay_state;
	unsigned short RelayState[MAX_MODS*4];

	/* Read interlock via serial line */

	try {
		send_cmd(READ_STATE,last_response);
	} catch(Tango::DevFailed &e) {
		sprintf(status,"No answer from controller (serial %s)\n",serial_line.c_str());
		strcat(status,e.errors[0].desc);
		set_status(status);
		set_state(Tango::UNKNOWN);
		strcpy(last_response,"");
		return get_state();
	}
   
	/* Check CC */

	read_argout=read_argout+6;
	if(read_argout[0] != '0' && read_argout[1] != '0')
	{
		sprintf(status,"Error on controller, unexpected answer \n");
		set_status(status);
		set_state(Tango::UNKNOWN);
		strcpy(last_response,"");
		return get_state();
	}
   
	/* Parse interlock */
  try {

    read_argout = read_argout + 6;
    for (k = 0, module = 0; module < MAX_MODS; module++) {
      sscanf(&(read_argout[k]), "%x", &rs);
      relay_state = (unsigned short) rs;

      RelayState[module * 4 + 0] = (relay_state & 0x000F);
      RelayState[module * 4 + 1] = (relay_state & 0x00F0) >> 4;
      RelayState[module * 4 + 2] = (relay_state & 0x0F00) >> 8;
      RelayState[module * 4 + 3] = (relay_state & 0xF000) >> 12;

      check_alarm(RelayState[module * 4 + 0], module, 0);
      check_alarm(RelayState[module * 4 + 1], module, 1);
      check_alarm(RelayState[module * 4 + 2], module, 2);
      check_alarm(RelayState[module * 4 + 3], module, 3);

      attr_Interlocks_read[module] =
              compact_state(module+1,1,RelayState[module * 4 + 0]) +
              compact_state(module+1,2,RelayState[module * 4 + 1]) * 4 +
              compact_state(module+1,3,RelayState[module * 4 + 2]) * 16 +
              compact_state(module+1,4,RelayState[module * 4 + 3]) * 64;

      k += 8;
    }

  } catch (Tango::DevFailed &e) {

    sprintf(status,"%s:%s",device_name.c_str(),e.errors[0].desc.in());
    set_status(status);
    set_state(Tango::UNKNOWN);
    strcpy(last_response,"");
    return get_state();

  }
   
	argout = Tango::ON;
	set_status("The device is working properly.");
	
	/*----- PROTECTED REGION END -----*/	//	Daresbury::dev_state
	set_state(argout);    // Give the state to Tango.
	if (argout!=Tango::ALARM)
		Tango::DeviceImpl::dev_state();
	return get_state();  // Return it after Tango management.
}
//--------------------------------------------------------
/**
 *	Command DevRead related method
 *	Description: Returns the response of the PSS hardware.
 *
 *	@returns Serial line response
 */
//--------------------------------------------------------
Tango::DevString Daresbury::dev_read()
{
	Tango::DevString argout;
	DEBUG_STREAM << "Daresbury::DevRead()  - " << device_name << std::endl;
	/*----- PROTECTED REGION ID(Daresbury::dev_read) ENABLED START -----*/
	
	//	Add your own code
	int lgth = strlen(last_response);

	if(lgth==0) {
		Tango::Except::throw_exception(
			(const char *)"Daresbury::error_read",
			(const char *)get_status().c_str(),
			(const char *)"Daresbury::dev_read");
	}
  
	argout  = new char[lgth+1];
	strcpy(argout, last_response);
	
	/*----- PROTECTED REGION END -----*/	//	Daresbury::dev_read
	return argout;
}
//--------------------------------------------------------
/**
 *	Command GetAllDescription related method
 *
 *
 *	@returns List of interlock description
 */
//--------------------------------------------------------
Tango::DevVarStringArray *Daresbury::get_all_description()
{
	Tango::DevVarStringArray *argout;
	DEBUG_STREAM << "Daresbury::GetAllDescription()  - " << device_name << std::endl;
	/*----- PROTECTED REGION ID(Daresbury::get_all_description) ENABLED START -----*/
	
	argout  = new Tango::DevVarStringArray();
	argout->length(MAX_MODS*8);
	
	int add;
	for(int i=0;i<MAX_MODS;i++) {
	  for(int j=0;j<8;j++) {

 	    add = i*8 + j;
	    if( descriptions[add] ) 
	      (*argout)[add] = CORBA::string_dup(descriptions[add]);	
	    else
	      (*argout)[add] = CORBA::string_dup("No description");
	      
	  }
	}
	
	/*----- PROTECTED REGION END -----*/	//	Daresbury::get_all_description
	return argout;
}
//--------------------------------------------------------
/**
 *	Command GetHistoryInfo related method
 *	Description: Returns a list of known logs.
 *
 *	@returns Return a list of interlock logs [date,reason]
 */
//--------------------------------------------------------
Tango::DevVarLongStringArray *Daresbury::get_history_info()
{
	Tango::DevVarLongStringArray *argout;
	DEBUG_STREAM << "Daresbury::GetHistoryInfo()  - " << device_name << std::endl;
	/*----- PROTECTED REGION ID(Daresbury::get_history_info) ENABLED START -----*/
	
	argout  = new Tango::DevVarLongStringArray();
	(argout->lvalue).length(nb_log);
	(argout->svalue).length(nb_log);

	for(int i=0;i<nb_log;i++) {
		(argout->lvalue)[i] = logs[i].log_time;
		(argout->svalue)[i] = CORBA::string_dup(logs[i].reason.c_str());
	}
	
	/*----- PROTECTED REGION END -----*/	//	Daresbury::get_history_info
	return argout;
}
//--------------------------------------------------------
/**
 *	Command GetInterlockDescription related method
 *
 *
 *	@param argin List of Interlock addresses : [Word address,Bit address]*
 *	@returns Interlock descrition string array
 */
//--------------------------------------------------------
Tango::DevVarStringArray *Daresbury::get_interlock_description(const Tango::DevVarLongArray *argin)
{
	Tango::DevVarStringArray *argout;
	DEBUG_STREAM << "Daresbury::GetInterlockDescription()  - " << device_name << std::endl;
	/*----- PROTECTED REGION ID(Daresbury::get_interlock_description) ENABLED START -----*/
	
	int i;
        char tmp[128];
	
	if( argin->length()%2 != 0 ) {
	
           Tango::Except::throw_exception(
              (const char *)"Daresbury::error_badparam",
              (const char *)"Invalid argin (must be a list a couple word address,bit address)",
              (const char *)"Daresbury::get_interlock_description");
	      
	}
	
	argout = new Tango::DevVarStringArray();
	argout->length(argin->length()/2);
	
	for(i=0;i<(int)argin->length();i+=2) {

	  int add = (*argin)[i]*8 + (*argin)[i+1];

	  if( add<0 || add>=MAX_MODS*8 ) {

	     sprintf(tmp,"Invalid interlock address at position ",i);
             Tango::Except::throw_exception(
        	  (const char *)"Daresbury::error_read",
        	  (const char *)tmp,
        	  (const char *)"Daresbury::get_interlock_description");
		  
	  }
	  
	  if( descriptions[add] ) 
	    (*argout)[i/2] = CORBA::string_dup(descriptions[add]);	
	  else
	    (*argout)[i/2] = CORBA::string_dup("No description");
	  
	}
	
	/*----- PROTECTED REGION END -----*/	//	Daresbury::get_interlock_description
	return argout;
}
//--------------------------------------------------------
/**
 *	Command GetInterlockState related method
 *
 *
 *	@param argin List of Interlock addresses : [Word address,Bit address]*
 *	@returns List of interlock state
 */
//--------------------------------------------------------
Tango::DevVarCharArray *Daresbury::get_interlock_state(const Tango::DevVarLongArray *argin)
{
	Tango::DevVarCharArray *argout;
	DEBUG_STREAM << "Daresbury::GetInterlockState()  - " << device_name << std::endl;
	/*----- PROTECTED REGION ID(Daresbury::get_interlock_state) ENABLED START -----*/
	
	int i;
        char tmp[128];

  if (argin->length() % 2 != 0) {

    Tango::Except::throw_exception(
            (const char *) "Daresbury::error_badparam",
            (const char *) "Invalid argin (must be a list a couple word address,bit address)",
            (const char *) "Daresbury::get_interlock_state");

  }

  if (get_state() != Tango::ON) {

    Tango::Except::throw_exception(
            (const char *) "Daresbury::error_read",
            (const char *) get_status().c_str(),
            (const char *) "Daresbury::get_interlock_state");
  }
	
	argout  = new Tango::DevVarCharArray();
	argout->length(argin->length()/2);
	
	for(i=0;i<(int)argin->length();i+=2) {

	  int add = (*argin)[i]*8 + (*argin)[i+1];

	  if( add<0 || add>=MAX_MODS*8 ) {

	     sprintf(tmp,"Invalid interlock address at position ",i);
             Tango::Except::throw_exception(
        	  (const char *)"Daresbury::error_read",
        	  (const char *)tmp,
        	  (const char *)"Daresbury::get_interlock_state");
		  
	  }
	  
	  // Extract interlock value
	  unsigned short bMask = 1 << (*argin)[i+1];
	  unsigned short value;
	  value = attr_Interlocks_read[(*argin)[i]];	  
	  (*argout)[i/2] = (value & bMask)?1:0;
	  	  
	}
	
	/*----- PROTECTED REGION END -----*/	//	Daresbury::get_interlock_state
	return argout;
}
//--------------------------------------------------------
/**
 *	Command ReadInterlockHistory related method
 *	Description: Returns the states of the interlock set of the specified log
 *
 *	@param argin Log time , see GetHistoryInfo
 *	@returns Array of interlock
 */
//--------------------------------------------------------
Tango::DevVarShortArray *Daresbury::read_interlock_history(Tango::DevLong argin)
{
	Tango::DevVarShortArray *argout;
	DEBUG_STREAM << "Daresbury::ReadInterlockHistory()  - " << device_name << std::endl;
	/*----- PROTECTED REGION ID(Daresbury::read_interlock_history) ENABLED START -----*/
	
	if( nb_log == 0 ) {
	
          Tango::Except::throw_exception(
        	  (const char *)"Daresbury::error_read",
        	  (const char *)"No history available.",
        	  (const char *)"Daresbury::read_interlock_history");
		  
	}
	
	int idx=0;
	int found=0;
	
	while(idx<nb_log && !found) {
	  found = (logs[idx].log_time==argin);
	  if(!found) idx++;
	}
	
	if( !found ) {
	
          Tango::Except::throw_exception(
        	  (const char *)"Daresbury::error_read",
        	  (const char *)"No history found at the specified time.",
        	  (const char *)"Daresbury::read_interlock_history");
	
	}
	
	argout = new Tango::DevVarShortArray();
	argout->length(MAX_MODS);
	
	for(int i=0;i<MAX_MODS;i++)
	  (*argout)[i] = logs[idx].itlk[i];
	
	/*----- PROTECTED REGION END -----*/	//	Daresbury::read_interlock_history
	return argout;
}
//--------------------------------------------------------
/**
 *	Command Reset related method
 *	Description: Reset the interlock system.
 *
 */
//--------------------------------------------------------
void Daresbury::reset()
{
	DEBUG_STREAM << "Daresbury::Reset()  - " << device_name << std::endl;
	/*----- PROTECTED REGION ID(Daresbury::reset) ENABLED START -----*/

	if( get_state() == Tango::ON )
		add_log("Reset");

	// Now reset
	send_cmd(RESET,NULL);
	
	/*----- PROTECTED REGION END -----*/	//	Daresbury::reset
}
//--------------------------------------------------------
/**
 *	Command SetInterlockDescription related method
 *	Description: Sets the descripton of the specified interlock.
 *
 *	@param argin argin[0]=Word address
 *	argin[1]=Bit address
 *	argin[2]=Interlock description
 */
//--------------------------------------------------------
void Daresbury::set_interlock_description(const Tango::DevVarStringArray *argin)
{
	DEBUG_STREAM << "Daresbury::SetInterlockDescription()  - " << device_name << std::endl;
	/*----- PROTECTED REGION ID(Daresbury::set_interlock_description) ENABLED START -----*/
	
	if( argin->length() != 3 ) {
	
           Tango::Except::throw_exception(
              (const char *)"Daresbury::error_set",
              (const char *)"Invalid argin: 2 values word address,bit address and 1 string expected.",
              (const char *)"Daresbury::set_interlock_description");
	}
	
	int wadd = atoi((*argin)[0]);
	int badd = atoi((*argin)[1]);
	int add = wadd*8 + badd;

	if( add<0 || add>=MAX_MODS*8 ) {

             Tango::Except::throw_exception(
        	  (const char *)"Daresbury::error_badparam",
        	  (const char *)"Invalid interlock address.",
        	  (const char *)"Daresbury::set_interlock_description");
		  
	}
	
	if( descriptions[add] ) 
	  free(descriptions[add]);
	
	descriptions[add] = strdup((*argin)[2]);
	save_description(wadd,badd);
	
	/*----- PROTECTED REGION END -----*/	//	Daresbury::set_interlock_description
}
//--------------------------------------------------------
/**
 *	Command EnableSMS related method
 *	Description: Enable SMS alarm for the specified interlock.
 *
 *	@param argin argin[0]=Word address
 *	argin[1]=Bit address
 */
//--------------------------------------------------------
void Daresbury::enable_sms(const Tango::DevVarLongArray *argin)
{
	DEBUG_STREAM << "Daresbury::EnableSMS()  - " << device_name << std::endl;
	/*----- PROTECTED REGION ID(Daresbury::enable_sms) ENABLED START -----*/
	
	if( argin->length() != 2 ) {
	
           Tango::Except::throw_exception(
              (const char *)"Daresbury::error_set",
              (const char *)"Invalid argin: 2 values word address,bit address expected.",
              (const char *)"Daresbury::enable_sms");
	}
	
	int wadd = (*argin)[0];
	int badd = (*argin)[1];
	int add = wadd*8 + badd;

	if( add<0 || add>=MAX_MODS*8 ) {

             Tango::Except::throw_exception(
        	  (const char *)"Daresbury::error_badparam",
        	  (const char *)"Invalid interlock address.",
        	  (const char *)"Daresbury::enable_sms");
		  
	}
	
	alarms[add].enabled_sms = true;
	save_alarm(wadd,badd);
	
	/*----- PROTECTED REGION END -----*/	//	Daresbury::enable_sms
}
//--------------------------------------------------------
/**
 *	Command DisableSMS related method
 *	Description: Disable SMS alarm for the specified interlock.
 *
 *	@param argin argin[0]=Word address
 *	argin[1]=Bit address
 */
//--------------------------------------------------------
void Daresbury::disable_sms(const Tango::DevVarLongArray *argin)
{
	DEBUG_STREAM << "Daresbury::DisableSMS()  - " << device_name << std::endl;
	/*----- PROTECTED REGION ID(Daresbury::disable_sms) ENABLED START -----*/
	
	if( argin->length() != 2 ) {
	
           Tango::Except::throw_exception(
              (const char *)"Daresbury::error_set",
              (const char *)"Invalid argin: 2 values word address,bit address expected.",
              (const char *)"Daresbury::enable_sms");
	}
	
	int wadd = (*argin)[0];
	int badd = (*argin)[1];
	int add = wadd*8 + badd;

	if( add<0 || add>=MAX_MODS*8 ) {

             Tango::Except::throw_exception(
        	  (const char *)"Daresbury::error_badparam",
        	  (const char *)"Invalid interlock address.",
        	  (const char *)"Daresbury::disable_sms");
		  
	}
	
	alarms[add].enabled_sms = false;
	save_alarm(wadd,badd);
	
	/*----- PROTECTED REGION END -----*/	//	Daresbury::disable_sms
}
//--------------------------------------------------------
/**
 *	Command GetSMS related method
 *
 *
 *	@param argin argin[0]=Word address
 *	argin[1]=Bit address
 *	@returns true if the SMS alarm is enabled for this interlock, false otherwise.
 */
//--------------------------------------------------------
Tango::DevBoolean Daresbury::get_sms(const Tango::DevVarLongArray *argin)
{
	Tango::DevBoolean argout;
	DEBUG_STREAM << "Daresbury::GetSMS()  - " << device_name << std::endl;
	/*----- PROTECTED REGION ID(Daresbury::get_sms) ENABLED START -----*/
	
	if( argin->length() != 2 ) {
	
           Tango::Except::throw_exception(
              (const char *)"Daresbury::error_set",
              (const char *)"Invalid argin: 2 values word address,bit address expected.",
              (const char *)"Daresbury::get_sms");
	}
	
	int wadd = (*argin)[0];
	int badd = (*argin)[1];
	int add = wadd*8 + badd;

	if( add<0 || add>=MAX_MODS*8 ) {

             Tango::Except::throw_exception(
        	  (const char *)"Daresbury::error_badparam",
        	  (const char *)"Invalid interlock address.",
        	  (const char *)"Daresbury::get_sms");
		  
	}
	
	argout = alarms[add].enabled_sms;
	
	/*----- PROTECTED REGION END -----*/	//	Daresbury::get_sms
	return argout;
}
//--------------------------------------------------------
/**
 *	Method     : Daresbury::add_dynamic_commands()
 *	Description: Create the dynamic commands if any
 *                for specified device.
 */
//--------------------------------------------------------
void Daresbury::add_dynamic_commands()
{
	/*----- PROTECTED REGION ID(Daresbury::add_dynamic_commands) ENABLED START -----*/
	
	//	Add your own code to create and add dynamic commands if any
	
	/*----- PROTECTED REGION END -----*/	//	Daresbury::add_dynamic_commands
}

/*----- PROTECTED REGION ID(Daresbury::namespace_ending) ENABLED START -----*/

//	Additional Methods
void Daresbury::save_property(char *name,char *value) {

    Tango::DbData	data;
    Tango::DbDatum  d(name);
    d << value;
    data.push_back(d);
    get_db_device()->put_property(data);

}

/*------------------------------------------------------------------*/

void Daresbury::load_alarms(int address) {

    char tmpName[128];
    int  add = address*8;
    int  bit;
    Tango::DbData   data;
    string read;
    
    for(bit=0;bit<8;bit++) {
      sprintf(tmpName,"sms_enabled.%d.%d",address,bit);
      data.push_back(Tango::DbDatum(tmpName));
    }
    
    get_db_device()->get_property(data);
    
    for(bit=0;bit<8;bit++) {

      alarms[add + bit].enabled_sms = true;
      alarms[add + bit].last_state = Tango::UNKNOWN;
      alarms[add + bit].alarm_time = 0;
      alarms[add + bit].sms_sent = false;

      if (data[bit].is_empty() == false) {
        data[bit] >> read;
        if (strcasecmp(read.c_str(), "false") == 0)
          alarms[add + bit].enabled_sms = false;
      }

    }

}

/*------------------------------------------------------------------*/

void Daresbury::save_alarm(int address,int bit) {
  
  char tmpName[128];
  int  add = address*8 + bit;

  sprintf(tmpName,"sms_enabled.%d.%d",address,bit);
  
  if( alarms[add].enabled_sms ) {
    save_property(tmpName,STR("true"));
  } else {
    save_property(tmpName,STR("false"));
  }
  
}

/*------------------------------------------------------------------*/

void Daresbury::load_descriptions(int address) {

    char tmpName[128];
    int  add = address*8;
    int  bit;
    Tango::DbData   data;
    string read;
    
    for(bit=0;bit<8;bit++) {
      sprintf(tmpName,"description.%d.%d",address,bit);
      data.push_back(Tango::DbDatum(tmpName));
    }
    
    get_db_device()->get_property(data);
    
    for(bit=0;bit<8;bit++) {
      if (data[bit].is_empty()==false)	{
        data[bit]  >>  read;
  	descriptions[add+bit]=strdup(read.c_str());
      }
    }
    
}

/*------------------------------------------------------------------*/

void Daresbury::save_description(int address,int bit) {
  
  char tmpName[128];
  int  add = address*8 + bit;

  sprintf(tmpName,"description.%d.%d",address,bit);
  
  if( descriptions[add] ) {
    save_property(tmpName,descriptions[add]);
  }
  
}

/*------------------------------------------------------------------*/
/*
void Daresbury::save_descriptions() {

  for(int i=0;i<MAX_MODS;i++) 
    for(int j=0;j<8;j++)
      save_description(i,j);

}
*/

/*------------------------------------------------------------------*/

void Daresbury::msleep(int ms)
{

#ifdef WIN32

    Sleep(ms);

#else    

    struct timespec tsleep;
    tsleep.tv_sec =   ms / 1000;
    tsleep.tv_nsec = (ms % 1000) * 1000000;
    nanosleep(&tsleep, NULL);

#endif

}

/*------------------------------------------------------------------*/

time_t Daresbury::get_ticks() {

#ifdef WIN32

  return GetTickCount();

#else

  struct timeval tv;
  gettimeofday(&tv,NULL);
  return ( (tv.tv_sec-start_time)*1000 + tv.tv_usec/1000 );

#endif

}

/*------------------------------------------------------------------

 Function:	static write_cmd(ds, argout )

 Description:	Write the command on the serial line, and read the answer.
   	
 Arg(s) In:     char		*cmd;   // Command to execute 
 Arg(s) Out:	char		*argout // Response

--------------------------------------------------------------------- */
void Daresbury::write_cmd(char *cmd, char *argout) {

  char *str = NULL, *str2;
  string reply;

#ifdef PRINT	
	time_t t0,t1;
	cout << " Daresbury::write_cmd() Sending: " << cmd << endl;
	t0 = get_ticks();
#endif

  if (argout) argout[0] = '\0';
	
	/* Flush the serial */ 	
	
	Tango::DeviceData flushMode;
	flushMode << (Tango::DevLong)2;
	theSerial->command_inout("DevSerFlush",flushMode);

  /* Send the command */

  Tango::DeviceData cmdArgin;
  Tango::DeviceData cmdArgout;
  Tango::DeviceData slMode;
  cmdArgin << cmd;
  theSerial->command_inout("DevSerWriteString", cmdArgin);
  slMode << (Tango::DevLong) SL_LINE;
	
	// RESET take ~1.5 sec to answer
	if(strcmp(cmd,RESET)==0) msleep(1200);
	
  cmdArgout = theSerial->command_inout("DevSerReadString",slMode);
	cmdArgout >> reply;
	str = (char *)reply.c_str();
	   
	/* Jump new line */
	
	if(str[0] == '\x0a')  str2=str+1;
	else  	              str2=str;

	/* Handle echo */
	
	if(strcmp(cmd,str2) == 0)
	{
 	  cmdArgout = theSerial->command_inout("DevSerReadString",slMode);
	  cmdArgout >> reply;
	  str = (char *)reply.c_str();
	}
	
	/* Jump new line */
	
	if(str[0] == '\x0a')  str2=str+1;
	else  	              str2=str;

	/* Get answer */
	
	if( argout )
	  strcpy(argout,str2);

#ifdef PRINT	
	t1 = get_ticks();
	cout << " Daresbury::write_cmd() Response: " << str2 << endl;
	cout << " Daresbury::write_cmd() Response: " << (t1-t0) << "ms" << endl;		
#endif
	
}

//------------------------------------------------------------------

void Daresbury::send_cmd(char *cmd, char *argout)
{
	write_cmd(cmd,argout);	
	if(argout!=NULL && strlen(argout)>=1)
	{
	  switch(argout[0])
	  {
	    case 's':  /* this is the first letter of "shell:" */
	    case '$':
	    //cerr << " pscoms apparently dead,restarting.... " << endl;
	    initialise_pscom();
	  }
	}
}

//------------------------------------------------------------------

void Daresbury::initialise_pscom() {

    if( init_pscom ) {
      // Kill the pscoms process
      write_cmd(STR("kill 4\x0d"),NULL);
      msleep(200);
    
      // Restart it.
      write_cmd(STR("Pscoms\x0d"),NULL);
      msleep(400);    
    }

}

/*------------------------------------------------------------------*/

short Daresbury::compact_state(int module,int relay,short state) {

  // According to the Daresbury PSS relay logic
  
  switch( state ) {
  
    case 0xF: // A and B closed
      return 3;
    case 0xA: // A open B closed
      return 2;
    case 0x5: // A closed B open
      return 1;
    case 0x0: // A and B open
      return 0;
    default:
      char errStr[256];
      sprintf(errStr,"Invalid state %X for Module:%d Relay:%d",state,module,relay);
      Tango::Except::throw_exception(
              (const char *)"Daresbury::error_read",
              (const char *)errStr,
              (const char *)"Daresbury::compact_state");

  }

}

/*------------------------------------------------------------------*/

void Daresbury::check_alarm(short state, int module, int relay) {

	Tango::DevState newState = get_relay_state(state);

	int add = relay * 2 + module * 8;

	//if( smsDevice==NULL || !alarms[add].enabled_sms ) {
	if (!alarms[add].enabled_sms) {
		// Does not check for alarm as there is nothing to send
		return;
	}

	if ((alarms[add].last_state != Tango::UNKNOWN) &&
			(alarms[add].last_state != newState) &&
			(newState == Tango::ALARM)) {

		alarms[add].alarm_time = time(NULL);

	}

	alarms[add].last_state = newState;

	if (newState == Tango::ALARM) {

		time_t now = time(NULL);
		if (now - alarms[add].alarm_time > 300) {

			// Trigger SMS
			if (!alarms[add].sms_sent) {

				char tmp[256];
				char message[256];
				char subject[256];

				strcpy(tmp, get_name().c_str());
				char *p = strchr(tmp, '/');
				p++;
				char *p2 = strrchr(p, '/');
				*p2 = 0;

				/*
        sprintf(message,"PSS ALARM %s Module %d Relay %d",p,module+1,relay+1);

              Tango::DeviceData data;
              vector<string> argin;
              argin.push_back(smsNumber);
              argin.push_back(message);
              data << argin;
              smsDevice->command_inout("SendSMS",data);
        */

				sprintf(subject, "PSS ALARM %s", p);
				for (int i = 0; i < (int) strlen(subject); i++) subject[i] = toupper(subject[i]);
				sprintf(message, "PSS ALARM on %s, Module %d, Relay %d", get_name().c_str(), module + 1, relay + 1);
				sprintf(tmp,"PSS Alarm %d/%d",module + 1, relay + 1);
				add_log(string(tmp));

				if (!mailSender->SendMessage(((DaresburyClass *) get_device_class())->mailDest,
																		 "pss@esrf.fr",
																		 subject,
																		 message)) {
					cerr << "Warning PSS alarm mail not sent" << endl;
					cerr << mailSender->GetLastError() << endl;
				}

				alarms[add].sms_sent = true;

			}

		}

	} else {

		alarms[add].sms_sent = false;

	}

}

/*------------------------------------------------------------------*/

void Daresbury::add_log(string reason) {

	if( nb_log>=MAX_LOG ) {
		// shift history
		for(int i=0;i<MAX_LOG-1;i++)
			logs[i] = logs[i+1];
	} else {
		nb_log++;
	}

	// Backup last state of relay
	logs[nb_log-1].log_time = time(NULL);
	logs[nb_log-1].reason = reason;
	memcpy(logs[nb_log-1].itlk,attr_Interlocks_read,MAX_MODS*sizeof(short));

}

/*------------------------------------------------------------------*/

Tango::DevState Daresbury::get_relay_state(short state) {

  switch( state ) {
  
    case 0xF: // A and B closed
      return Tango::CLOSE;
    case 0xA: // A open B closed
    case 0x5: // A closed B open
      return Tango::ALARM;
    case 0x0: // A and B open
      return Tango::OPEN;

  }

  return Tango::UNKNOWN;

}

/*----- PROTECTED REGION END -----*/	//	Daresbury::namespace_ending
} //	namespace
